﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ReadOnlyCellScrollDemoFlexGrid
{
    public partial class Form1 : Form
    {
        [DllImport("user32")]
        private static extern bool HideCaret(IntPtr hWnd);
        ArrayList _al = new ArrayList();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            string connectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" +
                         System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments),
                         @"ComponentOne Samples\Common\C1NWind.mdb") + ";";
            OleDbConnection conn = new OleDbConnection(connectionString);
            OleDbDataAdapter adapter = new OleDbDataAdapter("Select * from Cars", conn);
            adapter.Fill(dt);
            c1FlexGrid1.DataSource = dt;
            c1FlexGrid1.Rows.DefaultSize = 50;
            c1FlexGrid1.SetupEditor += C1FlexGrid1_SetupEditor;
            c1FlexGrid1.Cols[12].AllowEditing = false;
            c1FlexGrid1.SelChange += C1FlexGrid1_SelChange;
            c1FlexGrid1.Paint += C1FlexGrid1_Paint;
        }

      

        private void C1FlexGrid1_Paint(object sender, PaintEventArgs e)
        {
            
            foreach (HostedControl hosted in _al)
               hosted.UpdatePosition(c1FlexGrid1.Row,c1FlexGrid1.Col);
        }

        private void C1FlexGrid1_SelChange(object sender, EventArgs e)
        {
            if (c1FlexGrid1.Col == 12)
            {
                TextBox tbx = new TextBox();
                tbx.Multiline = true; // << need this to be able to set TextBox.Height
                tbx.ScrollBars = ScrollBars.Vertical;
                tbx.ReadOnly = true;
                tbx.GotFocus += Tbx_GotFocus;
                tbx.Text = c1FlexGrid1[c1FlexGrid1.Row, c1FlexGrid1.Col].ToString();
                _al.Add(new HostedControl(c1FlexGrid1, tbx, c1FlexGrid1.Row, c1FlexGrid1.Col));
            }
        }
        private void Tbx_GotFocus(object sender, EventArgs e)
        {
            TextBox textBox1 = sender as TextBox;
            if (textBox1.ReadOnly == true)
            {
                HideCaret(textBox1.Handle);
            } 
        }

        private void C1FlexGrid1_SetupEditor(object sender, C1.Win.C1FlexGrid.RowColEventArgs e)
        {
            TextBox tb = c1FlexGrid1.Editor as TextBox;
            tb.Multiline = true;
            tb.ScrollBars = ScrollBars.Vertical;
        }

        internal class HostedControl
        {
            internal C1FlexGrid _flex;
            internal Control _ctl;
            internal Row _row;
            internal Column _col;

            internal HostedControl(C1FlexGrid flex, Control hosted, int row, int col)
            {
                // save info
                _flex = flex;
                _ctl = hosted;
                _row = flex.Rows[row];
                _col = flex.Cols[col];

                // insert hosted control into grid
                _flex.Controls.Add(_ctl);
            }
            internal bool UpdatePosition(int row,int col)
            {
                // get row/col indices
                int r = _row.Index;
                int c = _col.Index;
                 if (r < 0 || c < 0) return false;
                //if (r != _flex.Row || r != _flex.Col) return false;
                // get cell rect
                Rectangle rc = _flex.GetCellRect(r, c, false);

                // hide control if out of range
                if (rc.Width <= 0 || rc.Height <= 0 || !rc.IntersectsWith(_flex.ClientRectangle) || row != r || col != c)
                {
                    _ctl.Visible = false;
                    return true;
                }

                // move the control and show it
                _ctl.Bounds = rc;
                _ctl.Visible = true;

                // done
                return true;
            }
        }
    }
}
